$fn=100;
difference(){
    union(){
        //body
        frame=[[0,0],[80,0],[80,137],[0,137],
               [3,3],[77,3],[77,134],[3,134]];
        paths_1=[[0,1,2,3]];
        paths_2=[[4,5,6,7]];

        //top
        translate([0,0,-5/2])
        linear_extrude(height = 5, center = true)
        polygon(frame,paths_1);
        
        //sides
        paths  = concat (paths_1,paths_2);

        translate([0,0,-40/2])
        linear_extrude(height = 40, center = true,convexity = 10)
        polygon(frame,paths);
        
        //shikiri
        translate([2,39,-15])cube(size=[76,2,10]);
        translate([2,77,-15])cube(size=[76,2,10]);
        
        //ashi
        translate([4,4,-17])ashi();
        translate([76,4,-17])ashi();
        translate([4,133,-35])ashi();
        translate([76,133,-35])ashi();       
        
    }  
    //ana
    #translate([-1,116,-20])rotate([0,90,0])cylinder( h=5,d=3.2);
    #translate([-1,21,-10])rotate([0,90,0])cylinder( h=5,d=3.2);   
    
    //1 
    translate([11.5,11.5,0])key();//0
    translate([30.5,11.5,0])key();//,
    translate([49.5,11.5,0])key();//3

    //2
    translate([11.5,30.5,0])key();//1
    translate([30.5,30.5,0])key();//2
    translate([49.5,30.5,0])key();//3
 
    //3
    translate([11.5,49.5,0])key();//4
    translate([30.5,49.5,0])key();//5
    translate([49.5,49.5,0])key();//6
   
    //4
    translate([11.5,68.5,0])key();//7
    translate([30.5,68.5,0])key();//8
    translate([49.5,68.5,0])key();//9
    //5
    translate([11.5,87.5,0])key();//HOME
    translate([30.5,87.5,0])key();//[/]
    translate([49.5,87.5,0])key();//*
    translate([68.5,87.5,0])key();//-
   
    //6
    translate([11.5,111.5,0])key();//END
    translate([30.5,111.5,0])key();//NUM LOCK
    translate([49.5,111.5,0])key();//INSERT
    translate([68.5,111.5,0])key();//PAUSE
    
    //RETURN
    translate([68.5,21,0])rotate([0,0,90])keyl();
    
    //+
    translate([68.5,59,0])rotate([0,0,90])keyl(); 

    translate([0,0,-10])rotate([-10,0,0])translate([-5,-5,-30])
    #cube(size=[90,150,30]);
    
    //HAISENN ANA
    translate([-7,49.5,-10])rotate([0,90,0])#cylinder( h=20, d=6);
    translate([-7,68.5,-10])rotate([0,90,0])#cylinder( h=20, d=6);
    translate([-7,87.5,-10])rotate([0,90,0])#cylinder( h=20, d=6);
    translate([-7,106.5,-10])rotate([0,90,0])#cylinder( h=20, d=6);
    translate([-7,125.5,-10])rotate([0,90,0])#cylinder( h=20, d=6);
    
}
//key hole
module key(){
    union(){
    translate( [ 0,0,-5/2] )cube( size=[14.2,14.2,5], center=true );
    translate([0,14.2/2+0.7,-3.1])cube( size=[5,1.4,3.8], center=true );
    translate([0,-14.2/2-0.7,-3.1])cube( size=[5,1.4,3.8], center=true );
    }
}
//key hole long
module keyl(){
    union(){
    translate( [ 0,0,-5/2] )cube( size=[14.2,14.2,5], center=true );
    translate([0,14.2/2+0.7,-3.1])cube( size=[5,1.4,3.8], center=true );
    translate([0,-14.2/2-0.7,-3.1])cube( size=[5,1.4,3.8], center=true );
        
    translate([11.9,0,0]){    
    translate([0,0,-5/2])cube( size=[3.4,14.2,5], center=true );
    translate([0,14.2/2+0.7,-3.1])cube( size=[3.4,1.4,3.8], center=true );
    translate([0,-14.2/2-0.7,-3.1])cube( size=[3.4,1.4,3.8], center=true );  
    }
    translate([-11.9,0,0]){    
    translate([0,0,-5/2])cube( size=[3.4,14.2,5], center=true );
    translate([0,14.2/2+0.7,-3.1])cube( size=[3.4,1.4,3.8], center=true );
    translate([0,-14.2/2-0.7,-3.1])cube( size=[3.4,1.4,3.8], center=true );  
    }   
    translate( [ 0,0,-5.5] )cube( size=[27.2,17,1], center=true );
    }
}
//ashi
module ashi(){
    union(){
        translate([0,0,10])sphere(d = 8);
        cylinder(h=10,d=8);
    }
}
